/* Troute.c 
 *      written by Jim Anderson September 1991
 *      Waldorf, MD
 */
/*
 *   Program presents the user with the option of having a random
 *   assignment of cities chosen for use with the ATP program
 */
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

#define MAX_TOWNS 26

struct airports
       { char name[30];
         float latitude, longitude;
         char  trigraph[10];
       };

void distance(float x, float y);
void insert_comma(char *string);

main()
{
 int x,y;                          /* Screen Coordinates           */
 static struct airports city[MAX_TOWNS];
                                   /* City database                */
 char ans;                         /* Input variable from keyboard */
 int  loop;                        /* Loop Counter                 */
 int  fpick, spick;                /*  Assignment variables        */
 static float lat_pass, long_pass; /* variables to pass delta lat/long
                                    * values                       */
 char tstr[80];                    /* temporary string variable    */
 FILE *fbat;
 void draw_box(void);
 int print_cities(struct airports city[], char *s);

 clrscr();
 printf("Do you wish to have a random ATP assignment? ");
 while ((ans = toupper(getch())) != 'Y' && ans != 'N')
       putchar('\a');
 putchar(ans);
 if (ans == 'N')
   {
    /*
     *   If the user doesn't want to have a random assignment just skip
     *   on by this whole program.
     */
    exit(0);
   }
 strcpy(city[0].name , "Albuquerque"); city[0].latitude = 35.042;
 city[0].longitude = 106.606;
 strcpy(city[0].trigraph, "ABQ");
 strcpy(city[1].name , "Atlanta"); city[1].latitude = 33.403;
 city[1].longitude = 84.427;
 strcpy(city[1].trigraph, "ATL");
 strcpy(city[2].name , "Boston"); city[2].latitude = 42.364;
 city[2].longitude = 71.006;
 strcpy(city[2].trigraph, "BOS");
 strcpy(city[3].name , "Chicago"); city[3].latitude = 41.98;
 city[3].longitude = 87.904;
 strcpy(city[3].trigraph, "ORD");
 strcpy(city[4].name , "Cleveland"); city[4].latitude = 41.411;
 city[4].longitude = 81.85;
 strcpy(city[4].trigraph, "CLE");
 strcpy(city[5].name , "Dallas"); city[5].latitude = 32.896;
 city[5].longitude = 97.041;
 strcpy(city[5].trigraph, "DFW");
 strcpy(city[6].name , "Denver"); city[6].latitude = 39.774;
 city[6].longitude = 104.879;
 strcpy(city[6].trigraph, "DEN");
 strcpy(city[7].name , "Detroit"); city[7].latitude = 42.215;
 city[7].longitude = 83.349;
 strcpy(city[7].trigraph, "DTW");
 strcpy(city[8].name , "Houston"); city[8].latitude = 29.98;
 city[8].longitude = 95.334;
 strcpy(city[8].trigraph, "IAH");
 strcpy(city[9].name , "Kansas City"); city[9].latitude = 39.299;
 city[9].longitude = 94.718;
 strcpy(city[9].trigraph, "MCI");
 strcpy(city[10].name , "Las Vegas"); city[10].latitude = 36.083;
 city[10].longitude = 115.154;
 strcpy(city[10].trigraph, "LAS");
 strcpy(city[11].name , "Los Angeles"); city[11].latitude = 33.943;
 city[11].longitude = 118.407;
 strcpy(city[11].trigraph, "LAX");
 strcpy(city[12].name , "Miami"); city[12].latitude = 25.793;
 city[12].longitude = 80.291;
 strcpy(city[12].trigraph, "MIA");
 strcpy(city[13].name , "Minneapolis"); city[13].latitude = 44.834;
 city[13].longitude = 93.215;
 strcpy(city[13].trigraph, "MSP");
 strcpy(city[14].name , "New Orleans"); city[14].latitude = 29.993;
 city[14].longitude = 90.256;
 strcpy(city[14].trigraph, "MSY");
 strcpy(city[15].name , "New York"); city[15].latitude = 40.640;
 city[15].longitude = 73.778;
 strcpy(city[15].trigraph, "JFK");
 strcpy(city[16].name , "Philadelphia"); city[16].latitude = 39.87;
 city[16].longitude = 75.245;
 strcpy(city[16].trigraph, "PHL");
 strcpy(city[17].name , "Phoenix"); city[17].latitude = 33.436;
 city[17].longitude = 112.009;
 strcpy(city[17].trigraph, "PHX");
 strcpy(city[18].name , "Pittsburgh"); city[18].latitude = 40.491;
 city[18].longitude = 80.233;
 strcpy(city[18].trigraph, "PIT");
 strcpy(city[19].name , "Salt Lake City"); city[19].latitude = 40.787;
 city[19].longitude = 111.968;
 strcpy(city[19].trigraph, "SLC");
 strcpy(city[20].name , "San Diego"); city[20].latitude = 32.734;
 city[20].longitude = 117.187;
 strcpy(city[20].trigraph, "SAN");
 strcpy(city[21].name , "San Francisco"); city[21].latitude = 37.619;
 city[21].longitude = 122.374;
 strcpy(city[21].trigraph, "SFO");
 strcpy(city[22].name , "Seattle"); city[22].latitude = 47.449;
 city[22].longitude = 122.308;
 strcpy(city[22].trigraph, "SEA");
 strcpy(city[23].name , "St Louis"); city[23].latitude = 38.748;
 city[23].longitude = 90.36;
 strcpy(city[23].trigraph, "STL");
 strcpy(city[24].name , "Tampa"); city[24].latitude = 27.975;
 city[24].longitude = 82.533;
 strcpy(city[24].trigraph, "TPA");
 strcpy(city[25].name , "Washington"); city[25].latitude = 38.944;
 city[25].longitude = 77.457;
 strcpy(city[25].trigraph, "IAD");
 do
 {
 y = 4;
 x = 8;
 randomize();
 fpick = random(26);
 /*
  *   If a W character is typed that means that we want to peg the departure
  *   city to Washington and only randomly pick the destination.
  */
 if (ans == 'W') fpick = 25;
 /*
  *     If a P is typed that means we will pick the departure city by hand
  *     and the program will pick the destination.
  */
 if (ans == 'P' || ans == 'B')
  {
    fpick = print_cities(city, "Departure");
  }
 /*  Assign the second city's variable to the same as the first, then we'll
  *  keep doing a random pick until we have two different towns */
 spick = fpick;
 /*  If we want to pick both cities select the second city now  */
 if (ans == 'B')
  {
   while (spick == fpick)
   {
    spick = print_cities(city, "Destination");
    if (spick == fpick)
    {
     gotoxy(5,21);
     printf("The destination cannot be %s! \x07", city[fpick].name);
     delay(2000);
    }
   }
  }
 /*
  *  If the second pick (spick) is still the same as the departure city
  *  randomly pick the destination else go on.
  */
 while (spick == fpick)
   {
    spick = random(26);
   }
 draw_box();
 gotoxy(5,5);
 printf("The Departure city is %s.\n", city[fpick].name);
 gotoxy(5,6);
 printf("The Destination city is %s.\n", city[spick].name);
 lat_pass = city[spick].latitude - city[fpick].latitude;
 if (lat_pass < 0) lat_pass *= -1;
 long_pass = city[spick].longitude - city[fpick].longitude;
 if (long_pass < 0) long_pass *= -1;
 distance(long_pass, lat_pass);
 gotoxy(5,20);
 printf("To pick Washington as the departure city; type 'W' below.\n");
 gotoxy(5,21);
 printf("To pick another city as the departure city; type 'P'.\n");
 gotoxy(5,22);
 printf("To pick both cities type 'B'.\n");
 gotoxy(5,23);
 printf("Are you ready to continue(Y/N/W/P/B)? ");
 }  while ((ans = toupper(getch())) != 'Y');
 fbat = fopen("rte.bat","w");
 /*
  *  Write out batch file to run the actual route program and it will
  *  be executed immediately after this program completes.
  */
 fprintf(fbat,"@echo off\n");
 fprintf(fbat, "cls\n");
 fprintf(fbat, "echo This program will generate the route on the printer.\n");
 fprintf(fbat, "echo Please be sure the printer is available or CTL/C to end.\n");
 fprintf(fbat, "pause\n");
 fprintf(fbat, "route %s %s > prn\n", city[fpick].trigraph,
                                      city[spick].trigraph);
 close(fbat);
 clrscr();
 return (0);
} /* Main */

void draw_box(void)
{
 int x,y;
 char tstr[] = "SubLogic Airlines Random Flight Assignment";
 clrscr();
 gotoxy(1,1);
 printf("\xC9");
 x = 1;
 for (y=2; y<=79; y++) printf("\xCD");
 printf("\xBB");
 gotoxy(1,2); printf("\xBA");
 gotoxy(80,2); printf("\xBA");
 x = strlen(tstr);
 x = 40 - (x/2);
 gotoxy(x,2); printf("%s",tstr);
 for (x=2; x<80; x++)
  {
  gotoxy(x,3);
  printf("\xCD");
  }
 gotoxy(1,3); printf("\xCC");
 gotoxy(80,3); printf("\xB9");
 for (y=4; y<24; y++)
  {
  gotoxy(1,y); printf("\xBA");
  gotoxy(80,y); printf("\xBA");
  }
 gotoxy(1,24); printf("\xC8");
 gotoxy(80,24); printf("\xBC");
 for (x=2; x<80; x++)
  {
  gotoxy(x,24); printf("\xCD");
  }
 gotoxy(4,4);
}

void distance(float x, float y)
{
    double myhyp, how_long, hours, minutes;
    char tstr[80];

    myhyp = hypot( (double) x, (double) y);
    how_long = (myhyp * 60) / 250;
    hours = abs(how_long);
    minutes = abs((how_long - hours) * 60);
    sprintf(tstr, "%.0lf", myhyp * 60);
    insert_comma(tstr);
    gotoxy(5,13);
    printf("The distance involved is %s miles.\n", tstr);
    gotoxy(5,14);
    printf("Travel time is approximately");
    if (hours > 1)
     printf(" %.0lf hours", hours);
    if (hours == 1.0)
     printf(" %.0lf hour", hours);
    if (minutes == 1.0) printf(" %.0lf minute", minutes);
    if (minutes > 1.0)  printf(" %.0lf minutes", minutes);
    printf(".\n");
}   /* end distance */

void insert_comma(char *string)
/* This routine puts a comma into a string containing an integer number */
{
 int x,y;
 float spot;
 int cdown, bcnt = 0;
 char tstr[81];
 x = strlen(string);
 spot = x;
 if (x>0)
  {
  tstr[0] = string[0];
  for (y=1;y<=x;y++)
   {
   spot -= 1.0; cdown = spot;
   if (((spot/3) - (cdown/3) == 0.0) && (spot != 0.0))
     {
     bcnt++;
     tstr[bcnt] = ',';
     bcnt++;
     tstr[bcnt] = string[y];
     }
   else
     {
     bcnt++;
     tstr[bcnt] = string[y];
     }
  } /* for y */
  } /* if x */
 strcpy(string,tstr);
} /* end insert_comma() */

int print_cities(struct airports city[],char *str)
{
    /*
     *  This routine draws the cities on the screen so the user can pick
     *  one to be the starting point or ending point.
     */

    int x,y;                                /* screen locators            */
    int pick;                               /* actual number picked       */
    char ans;                               /* selection                  */
    int loop;                               /* loop counter               */
    char tstr[80];                          /* holding string variable    */
    void draw_box(void);                    /* clr screen and draw border */

    draw_box();                             /* draw the box */
    x = y = 4;                              /* init to 4,4  */
    for (loop = 0; loop < MAX_TOWNS; loop++)
        {
            if (loop > 12)
            {
                x = 36;
                y = 4 + (loop - 13);
            }
            gotoxy(x,y);
            printf("%c) %s", loop + 0x41, city[loop].name);
            y++;
        }   /* end loop */
        gotoxy(5,22);
        sprintf(tstr,"Select %s City: ", str);
        printf("%s", tstr);
        x = strlen(tstr);
        do
        {
        gotoxy(x+5,22);
        printf("     ");
        gotoxy(x+5,22);
        while ((ans = toupper(getch())) < 'A' && ans > 'Z')
              putchar('\a'); toupper
        putchar(ans);
        } while (!isalpha(ans));
        pick = ans - 0x41;
        return(pick);

}   /* end print_cities() */
